﻿# coding: utf-8

import fdb
import argparse
from math import log10, floor

args =[]
wyniki=[]  # tabela wartosci stężeń dla wszystkich punktów w siatce i jednej substancji
substancje = []


parser = argparse.ArgumentParser(description='Parametery wydruku stężeń maksymalnych')

#Definiujemy mośliwe do użycia argumenty.

parser.add_argument('plik_projektu', help="Nazwa pliku projektu Operat FB ")
parser.add_argument('plik_bazy_subst', help="Nazwa pliku zawierającego listę substancji - domyślnie subst_wsk_roze.fb")
args = parser.parse_args()

#lączenie sie do projektu

#print ('łaczenie...')

try:
    con_opc = fdb.connect(dsn=args.plik_projektu, user='SYSDBA', password='masterkey')

except BaseException as error:
    print("Nie można się połączyć do pliku: ", args.plik_projektu, " Błąd: ", error)
    SystemExit


class Substancja:
    nazwa=""
    nazwa_dop=""
    faza=0   # 0= gaz, 1=pył 2=odorant
    D1=0
    Da=0
    objeta_wart_dop=True   # czy substancja jest objętqa wartościami odniesienia lub dopuszczalnymi


class Siatka:

    def __init__(self):
        self.yk =0
        self.xp=0
        self.yp=0
        self.dx=0
        self.dy=0
        self.xk=0
        self.ile_punktow=0
        self.regularna=True

    def wys(self):  # liczba wierszy
        return int((self.yk - self.yp) / self.dy) + 1

    def szer(self):  # liczba kolumn
        return int((self.xk - self.xp) / self.dx)+1


tytuly = ["maksymalnych","średniorocznych", "percentyla 99,8","percentyla 98",
            "częstośći przekroczeń","częstośći przekroczeń","częstośći przekroczeń","częstośći przekroczeń","częstośći przekroczeń","częstośći przekroczeń",
            "opadu pyłu", "opadu pyłu+tło",
            "opadu ołowiu","opadu ołowiu+tło",
            "opadu kadmu", "opadu kadmu+tło",
            "stężeń średniorocznych+tło"]


# odczyt siatki, listy obliczanych substancji i opcji substancji (tło)

class Opcje_projektu:

    def __init__(self):
        self.obliczane = []
        self.wysok_obl = 0
        self.siatka= Siatka()


    def odczyt(self):
        global args,con_opc

        # utworz kursor do polaczenia
        cur_opc = con_opc.cursor()

        # otwórz SELECT
        cur_opc.execute("SELECT DISTINCT NR_ZAN FROM OPCJE_ZANIECZ WHERE OBLICZANE = 'T' AND TYP = 0 order by NR_KOL_WYB")
        self.obliczane = cur_opc.fetchall()
        cur_opc.close()

        cur_opc.execute( 'select WYSOK_OBL,  KSZTALT_SIATKI,  POCZ_X,   SKOK_X,  KONIEC_X,  POCZ_Y,  SKOK_Y,  KONIEC_Y, ILE_PKTOW from ZAKLAD')
        row = cur_opc.fetchone()
        self.wysok_obl = row[0]
        # 0 Przeplot, 1 Prostokątna, 2 Ręcznie, 3 PodKątem, 4 sWzdłużDrogi, 5 PunktyPrzyDrodze, 6  Nieregularna
        self.regularna = row[1]  in (1,4)
        self.siatka.xp = row[2]
        self.siatka.dx = row[3]
        self.siatka.xk = row[4]
        self.siatka.yp = row[5]
        self.siatka.dy = row[6]
        self.siatka.yk = row[7]
        self.siatka.ile_punktow= row[8]

        cur_opc.close()



class Opcje_substancji:
    def __init__(self):
            self.typ = 0
            self.obliczane = False  # czy substancja jest obliozana w pelnym zakresie
            self.nazwa = ""
            self.nazwa_dop = ""
            self.tlo = 0
            self.koma_max = 1
            self.komax_sr = 3
            self.ile_poziomow =0
            self.poziomy = []
            self.tytul1 = ""  # zapisany przez użytkownika
            self.tytul2 = ""


    #kod typu : (izMax {0}, izSred, izPerc998, izPerc98, izCzas1, izCzas2, izCzas3, izCzas4, izCzas5, izCzas6,
    # izOpad { 10 } , izOpadiTlo,{11}
    # izOpadOlowiu, izOpadOlowiuiTlo, {12,13}
    # izOpadKadmu, izOpadKadmuiTlo, {14,15}
    # izSrediTlo { 16 }


    def odczyt(self,con,nr_zan, typ):        #nr_zan od 0
        cur_opc = con.cursor()

        cur_opc.execute("SELECT * FROM OPCJE_ZANIECZ WHERE TYP= "+str(typ)+" AND NR_ZAN= "+str(nr_zan))

        for row in cur_opc.fetchallmap(): #odczytywany tylko jednen rekord
            self.tytul1 = row["tytul1"]
            self.tytul2 = row["tytul2"]
            self.koma_max=row["koma_max"]
            self.koma_sr =row["koma_sr"]
            self.poziomy = []
            self.ile_poziomow = row["ile_poziomow"]


            if self.ile_poziomow:
                for n in range(1,self.ile_poziomow):
                    self.poziomy.append( row["poziom"+str(n)])

        if not self.tytul1:    # tytuł nie jest zapisany - bedzie ustalony autom.
            t =tytuly[typ]
            if  typ in (0,1,2,3,4,5,6,7,8,9,16):
                t = t+" "+substancje[nr_zan-1].nazwa_dop+' µg/m³'
            elif typ in (10,11):
                t = t+' g/m²/rok'
            elif typ in (11,12,13,14,15):
                t = t+' mg/m²/rok'
            self.tytul1 ="Wykres "+ t
            #print("tytul określony przez program: ", self.opcje.tytul1 )
            return self.ile_poziomow>0

        cur_opc.close()



def read_params():
    global args
    parser = argparse.ArgumentParser(description='Parametery wykresu izolinii')

    #Definiujemy możliwe do użycia argumenty.

    parser.add_argument('plik_projektu', help="Nazwa pliku projektu Operat FB ")
    parser.add_argument('plik_bazy_subst', help="Nazwa pliku zawierającego listę substancji - domyslnie subst_Wsk_roze.fb")
    args = parser.parse_args()


#  Odczyt substancji z ogólnej listy

def odczyt_substan():
    global args
    global substancje

    try:
       con_subst = fdb.connect (dsn=args.plik_bazy_subst, user='SYSDBA', password='masterkey')
    except BaseException as error:
       print ("Nie można się połaczyć do pliku: ",args.plik_bazy_subst," Błąd: ",error)
       SystemExit

    cur_subst = con_subst.cursor()
    cur_subst.execute("select * from substancje order by NR")

    nrs = 0

    for row in cur_subst.itermap():
        substancje.append(Substancja())
        substancje[nrs].faza = row["faza"]
        substancje[nrs].nazwa = row["nazwa"]
        substancje[nrs].nazwa_dop = row["nazwa_dop"]
        substancje[nrs].D1 = row["D30"]
        substancje[nrs].Da = row["Da"]
        substancje[nrs].objeta_wart_dop = row["NOWA_NORMA"]
        nrs += 1

    con_subst.close()
    return nrs


def mnoznik_stez(nr_zan):
   global substancje
   if substancje[nr_zan].faza == 2:  # odory, azbest
        return 1
   else:
        return 1000



# pola WYNIK : stęż.max = WYNIK1, śednie= WYNIK2, Perc998=WYNIK3, perc98=WYNIK4, Czas=WYNIK5 (czestość przekroczeń lub czas przekroczen stezne zażożonego S1
#         typ     0                   1                2             3              4

# zwraca tabelę wyników, tylko dla siatki regularnej

def odczyt_wynikow_stez_regul (con, nr_zan,typ, siatka):  #nr_zan = nr w bazie substancji
    global wyniki

    if typ < 4:
        mn = mnoznik_stez(nr_zan)
    else:
        mn =1

    ny = siatka.wys()
    nx = siatka.szer()

    pole= "WYNIK"+str(typ+1)

    #print ("pole: ",pole)


    #utwórz tablice na ny kolumn i nx wierszy
    wyniki = [[0] * nx for i in range(ny)] #odwrotnie

    cur = con.cursor()

    query = " select count(*) from WYNIKI where NR_ZAN =" + str(nr_zan) \
           + " and TYP =1 " \
           + " and NR_PUNKTU <= " + str(siatka.ile_punktow)

    #cur.execute(query)
    #wynik= cur.fetchone()
    #print("po zapytaniu",wynik[0]), "rekordów")

    query =" select * from WYNIKI where NR_ZAN ="+str(nr_zan)\
           +" and TYP =1 " \
           +" and NR_PUNKTU <= " +str(siatka.ile_punktow)
    cur.execute(query)


    for row in cur.itermap():
        p = row["NR_PUNKTU"]  # od 1..ile_puntow
        c = ((p - 1)  % nx)  # mod szer
        r = ((p - 1) // nx) # div
        wyniki[r][c] = row[pole]*mn # mikrogramy [x,y]


def round_sig(x, sig=2):
    return round(x, sig-int(floor(log10(abs(x))))-1)